commit 77f51ab52049734d80a8ccb79b80189c7fb95c41
Author: Erik Skultety <eskultet@redhat.com>
Date:   Thu Aug 9 15:27:26 2018 +0200

    qemu: caps: Format SEV platform data into qemuCaps cache
    
    Since we're not saving the platform-specific data into a cache, we're
    not going to populate the structure, which in turn will cause a crash
    upon calling virNodeGetSEVInfo because of a NULL pointer dereference.
    Ultimately, we should start caching this data along with host-specific
    capabilities like NUMA and SELinux stuff into a separate cache, but for
    the time being, this is a semi-proper fix for a potential crash.
    
    Backtrace (requires libvirtd restart to load qemu caps from cache):
        #0 qemuGetSEVInfoToParams
        #1 qemuNodeGetSEVInfo
        #2 virNodeGetSEVInfo
        #3 remoteDispatchNodeGetSevInfo
        #4 remoteDispatchNodeGetSevInfoHelper
        #5 virNetServerProgramDispatchCall
        #6 virNetServerProgramDispatch
        #7 virNetServerProcessMsg
        #8 virNetServerHandleJob
        #9 virThreadPoolWorker
        #10 virThreadHelper
    
    https: //bugzilla.redhat.com/show_bug.cgi?id=1612009
    Signed-off-by: Erik Skultety <eskultet@redhat.com>
    Acked-by: Peter Krempa <pkrempa@redhat.com>
    Tested-by: Brijesh Singh <brijesh.singh@amd.com>

Index: libvirt-4.0.0/src/qemu/qemu_capabilities.c
===================================================================
--- libvirt-4.0.0.orig/src/qemu/qemu_capabilities.c
+++ libvirt-4.0.0/src/qemu/qemu_capabilities.c
@@ -2283,6 +2283,30 @@ virQEMUCapsHostCPUDataClear(virQEMUCapsH
 }
 
 
+static int
+virQEMUCapsSEVInfoCopy(virSEVCapabilityPtr *dst,
+                       virSEVCapabilityPtr src)
+{
+    int ret = -1;
+    virSEVCapabilityPtr tmp = NULL;
+
+    if (VIR_ALLOC(tmp) < 0)
+        return -1;
+    
+    if (VIR_STRDUP(tmp->pdh, src->pdh) < 0 ||
+        VIR_STRDUP(tmp->cert_chain, src->cert_chain) < 0) {
+        VIR_FREE(tmp);
+        return -1;
+    }
+
+    tmp->cbitpos = src->cbitpos;
+    tmp->reduced_phys_bits = src->reduced_phys_bits;
+
+    VIR_STEAL_PTR(*dst, tmp);
+    return 0;
+}
+
+
 virQEMUCapsPtr virQEMUCapsNewCopy(virQEMUCapsPtr qemuCaps)
 {
     virQEMUCapsPtr ret = virQEMUCapsNew();
@@ -2342,6 +2366,11 @@ virQEMUCapsPtr virQEMUCapsNewCopy(virQEM
     for (i = 0; i < qemuCaps->ngicCapabilities; i++)
         ret->gicCapabilities[i] = qemuCaps->gicCapabilities[i];
 
+    if (virQEMUCapsGet(qemuCaps, QEMU_CAPS_SEV_GUEST) &&
+        virQEMUCapsSEVInfoCopy(&ret->sevCapabilities,
+                               qemuCaps->sevCapabilities) < 0)
+        goto error;
+
     return ret;
 
  error:
@@ -3877,6 +3906,62 @@ virQEMUCapsCachePrivFree(void *privData)
 }
 
 
+static int
+virQEMUCapsParseSEVInfo(virQEMUCapsPtr qemuCaps, xmlXPathContextPtr ctxt)
+{
+    virSEVCapabilityPtr sev = NULL;
+
+    if (!virQEMUCapsGet(qemuCaps, QEMU_CAPS_SEV_GUEST))
+        return 0;
+
+    if (virXPathBoolean("boolean(./sev)", ctxt) == 0) {
+        virReportError(VIR_ERR_XML_ERROR, "%s",
+                       _("missing SEV platform data in QEMU "
+                         "capabilities cache"));
+        return -1;
+    }
+
+    if (VIR_ALLOC(sev) < 0)
+        return -1;
+
+    if (virXPathUInt("string(./sev/cbitpos)", ctxt, &sev->cbitpos) < 0) {
+        virReportError(VIR_ERR_XML_ERROR, "%s",
+                       _("missing or malformed SEV cbitpos information "
+                         "in QEMU capabilities cache"));
+        goto error;
+    }
+
+    if (virXPathUInt("string(./sev/reducedPhysBits)", ctxt,
+                     &sev->reduced_phys_bits) < 0) {
+        virReportError(VIR_ERR_XML_ERROR, "%s",
+                       _("missing or malformed SEV reducedPhysBits information "
+                         "in QEMU capabilities cache"));
+        goto error;
+    }
+
+    if (!(sev->pdh = virXPathString("string(./sev/pdh)", ctxt)))  {
+        virReportError(VIR_ERR_XML_ERROR, "%s",
+                       _("missing SEV pdh information "
+                         "in QEMU capabilities cache"));
+        goto error;
+    }
+
+    if (!(sev->cert_chain = virXPathString("string(./sev/certChain)", ctxt))) {
+        virReportError(VIR_ERR_XML_ERROR, "%s",
+                       _("missing SEV certChain information "
+                         "in QEMU capabilities cache"));
+        goto error;
+    }
+
+    VIR_STEAL_PTR(qemuCaps->sevCapabilities, sev);
+    return 0;
+
+error:
+    VIR_FREE(sev);
+    return -1;
+}
+
+
 /*
  * Parsing a doc that looks like
  *
@@ -4119,6 +4204,9 @@ virQEMUCapsLoadCache(virArch hostArch,
     }
     VIR_FREE(nodes);
 
+    if (virQEMUCapsParseSEVInfo(qemuCaps, ctxt) < 0)
+        goto cleanup;
+
     virQEMUCapsInitHostCPUModel(qemuCaps, hostArch, VIR_DOMAIN_VIRT_KVM);
     virQEMUCapsInitHostCPUModel(qemuCaps, hostArch, VIR_DOMAIN_VIRT_QEMU);
 
@@ -4236,6 +4324,24 @@ virQEMUCapsFormatCPUModels(virQEMUCapsPt
 }
 
 
+static void
+virQEMUCapsFormatSEVInfo(virQEMUCapsPtr qemuCaps, virBufferPtr buf)
+{
+    virSEVCapabilityPtr sev = virQEMUCapsGetSEVCapabilities(qemuCaps);
+
+    virBufferAddLit(buf, "<sev>\n");
+    virBufferAdjustIndent(buf, 2);
+    virBufferAsprintf(buf, "<cbitpos>%u</cbitpos>\n", sev->cbitpos);
+    virBufferAsprintf(buf, "<reducedPhysBits>%u</reducedPhysBits>\n",
+                      sev->reduced_phys_bits);
+    virBufferEscapeString(buf, "<pdh>%s</pdh>\n", sev->pdh);
+    virBufferEscapeString(buf, "<certChain>%s</certChain>\n",
+                          sev->cert_chain);
+    virBufferAdjustIndent(buf, -2);
+    virBufferAddLit(buf, "</sev>\n");
+}
+
+
 char *
 virQEMUCapsFormatCache(virQEMUCapsPtr qemuCaps)
 {
@@ -4313,6 +4419,9 @@ virQEMUCapsFormatCache(virQEMUCapsPtr qe
                           emulated ? "yes" : "no");
     }
 
+    if (qemuCaps->sevCapabilities)
+        virQEMUCapsFormatSEVInfo(qemuCaps, &buf);
+
     virBufferAdjustIndent(&buf, -2);
     virBufferAddLit(&buf, "</qemuCaps>\n");
 