From 6409e928eb4c2287dca59b139650fab77ea99fb8 Mon Sep 17 00:00:00 2001
From: Olaf Hering <olaf@aepfle.de>
Date: Fri, 9 May 2014 11:55:31 -0600
Subject: [PATCH] libvirt: set migration constraints from cmdline

References: fate#316614

Signed-off-by: Olaf Hering <olaf@aepfle.de>
Signed-off-by: Jim Fehlig <jfehlig@suse.com>
---
 include/libvirt/libvirt-domain.h |   25 +++++++++++++++++++++++++
 src/libxl/libxl_driver.c         |   17 ++++++++++++++++-
 src/libxl/libxl_migration.c      |   29 +++++++++++++++++++++++++----
 src/libxl/libxl_migration.h      |   14 +++++++++++++-
 tools/virsh-domain.c             |   38 ++++++++++++++++++++++++++++++++++++++
 tools/virsh.pod                  |    8 ++++++++
 6 files changed, 125 insertions(+), 6 deletions(-)

Index: libvirt-4.0.0/include/libvirt/libvirt-domain.h
===================================================================
--- libvirt-4.0.0.orig/include/libvirt/libvirt-domain.h
+++ libvirt-4.0.0/include/libvirt/libvirt-domain.h
@@ -1008,6 +1008,31 @@ typedef enum {
  */
 # define VIR_MIGRATE_PARAM_AUTO_CONVERGE_INCREMENT  "auto_converge.increment"
 
+/**
+ * VIR_MIGRATE_PARAM_SUSE_MAX_ITERS:
+ *
+ * virDomainMigrate* params field: xc_domain_save max_iters
+ */
+#define VIR_MIGRATE_PARAM_SUSE_MAX_ITERS     "max_iters"
+/**
+ * VIR_MIGRATE_PARAM_SUSE_MAX_FACTOR:
+ *
+ * virDomainMigrate* params field: xc_domain_save max_factor
+ */
+#define VIR_MIGRATE_PARAM_SUSE_MAX_FACTOR    "max_factor"
+/**
+ * VIR_MIGRATE_PARAM_SUSE_MIN_REMAINING:
+ *
+ * virDomainMigrate* params field: xc_domain_save min_remaining
+ */
+#define VIR_MIGRATE_PARAM_SUSE_MIN_REMAINING "min_remaining"
+/**
+ * VIR_MIGRATE_PARAM_SUSE_ABORT_IF_BUSY:
+ *
+ * virDomainMigrate* params field: xc_domain_save abort_if_busy
+ */
+#define VIR_MIGRATE_PARAM_SUSE_ABORT_IF_BUSY "abort_if_busy"
+
 /* Domain migration. */
 virDomainPtr virDomainMigrate (virDomainPtr domain, virConnectPtr dconn,
                                unsigned long flags, const char *dname,
Index: libvirt-4.0.0/src/libxl/libxl_driver.c
===================================================================
--- libvirt-4.0.0.orig/src/libxl/libxl_driver.c
+++ libvirt-4.0.0/src/libxl/libxl_driver.c
@@ -6081,6 +6081,9 @@ libxlDomainMigratePerform3Params(virDoma
     const char *dname = NULL;
     const char *uri = NULL;
     int ret = -1;
+    libxlDomainMigrationProps props = {
+        .virFlags = flags,
+    };
 
 #ifdef LIBXL_HAVE_NO_SUSPEND_RESUME
     virReportUnsupportedError();
@@ -6097,6 +6100,18 @@ libxlDomainMigratePerform3Params(virDoma
         virTypedParamsGetString(params, nparams,
                                 VIR_MIGRATE_PARAM_DEST_NAME,
                                 &dname) < 0 ||
+        virTypedParamsGetUInt(params, nparams,
+                                VIR_MIGRATE_PARAM_SUSE_MAX_ITERS,
+                                &props.max_iters) < 0 ||
+        virTypedParamsGetUInt(params, nparams,
+                                VIR_MIGRATE_PARAM_SUSE_MAX_FACTOR,
+                                &props.max_factor) < 0 ||
+        virTypedParamsGetUInt(params, nparams,
+                                VIR_MIGRATE_PARAM_SUSE_MIN_REMAINING,
+                                &props.min_remaining) < 0 ||
+        virTypedParamsGetUInt(params, nparams,
+                                VIR_MIGRATE_PARAM_SUSE_ABORT_IF_BUSY,
+                                &props.abort_if_busy) < 0 ||
         virTypedParamsGetString(params, nparams,
                                 VIR_MIGRATE_PARAM_URI,
                                 &uri) < 0)
@@ -6111,11 +6126,11 @@ libxlDomainMigratePerform3Params(virDoma
 
     if ((flags & (VIR_MIGRATE_TUNNELLED | VIR_MIGRATE_PEER2PEER))) {
         if (libxlDomainMigrationPerformP2P(driver, vm, dom->conn, dom_xml,
-                                           dconnuri, uri, dname, flags) < 0)
+                                           dconnuri, uri, dname, &props) < 0)
             goto cleanup;
     } else {
         if (libxlDomainMigrationPerform(driver, vm, dom_xml, dconnuri,
-                                        uri, dname, flags) < 0)
+                                        uri, dname, &props) < 0)
             goto cleanup;
     }
 
Index: libvirt-4.0.0/src/libxl/libxl_migration.c
===================================================================
--- libvirt-4.0.0.orig/src/libxl/libxl_migration.c
+++ libvirt-4.0.0/src/libxl/libxl_migration.c
@@ -347,18 +347,39 @@ libxlMigrateReceive(virNetSocketPtr sock
 static int
 libxlDoMigrateSend(libxlDriverPrivatePtr driver,
                    virDomainObjPtr vm,
-                   unsigned long flags,
+                   const libxlDomainMigrationProps *props,
                    int sockfd)
 {
     libxlDriverConfigPtr cfg = libxlDriverConfigGet(driver);
+#ifdef LIBXL_HAVE_DOMAIN_SUSPEND_SUSE
+    libxl_domain_suspend_suse_properties libxl_props = {
+        .flags = 0,
+    };
+#else
     int xl_flags = 0;
+#endif
     int ret;
 
-    if (flags & VIR_MIGRATE_LIVE)
+#ifdef LIBXL_HAVE_DOMAIN_SUSPEND_SUSE
+    if (props->virFlags & VIR_MIGRATE_LIVE)
+        libxl_props.flags |= LIBXL_SUSPEND_LIVE;
+
+    libxl_props.max_iters = props->max_iters;
+    libxl_props.max_factor = props->max_factor;
+    libxl_props.min_remaining = props->min_remaining;
+    if (props->abort_if_busy)
+        libxl_props.flags |= LIBXL_SUSPEND_ABORT_IF_BUSY;
+
+    ret = libxl_domain_suspend_suse(cfg->ctx, vm->def->id, sockfd,
+                                    &libxl_props, NULL);
+#else
+    if (props->virFlags & VIR_MIGRATE_LIVE)
         xl_flags = LIBXL_SUSPEND_LIVE;
 
     ret = libxl_domain_suspend(cfg->ctx, vm->def->id, sockfd,
                                xl_flags, NULL);
+#endif
+
     if (ret != 0) {
         virReportError(VIR_ERR_INTERNAL_ERROR, "%s",
                        _("Failed to send migration data to destination host"));
@@ -928,7 +949,7 @@ struct libxlTunnelControl {
 static int
 libxlMigrationStartTunnel(libxlDriverPrivatePtr driver,
                           virDomainObjPtr vm,
-                          unsigned long flags,
+                          const libxlDomainMigrationProps *props,
                           virStreamPtr st,
                           struct libxlTunnelControl **tnl)
 {
@@ -961,7 +982,7 @@ libxlMigrationStartTunnel(libxlDriverPri
 
     virObjectUnlock(vm);
     /* Send data to pipe */
-    ret = libxlDoMigrateSend(driver, vm, flags, tc->dataFD[1]);
+    ret = libxlDoMigrateSend(driver, vm, props, tc->dataFD[1]);
     virObjectLock(vm);
 
  out:
@@ -996,7 +1017,7 @@ libxlDoMigrateP2P(libxlDriverPrivatePtr
                   const char *dconnuri ATTRIBUTE_UNUSED,
                   const char *dname,
                   const char *uri,
-                  unsigned int flags)
+                  const libxlDomainMigrationProps *props)
 {
     virDomainPtr ddomain = NULL;
     virTypedParameterPtr params = NULL;
@@ -1041,11 +1062,11 @@ libxlDoMigrateP2P(libxlDriverPrivatePtr
     /* We don't require the destination to have P2P support
      * as it looks to be normal migration from the receiver perpective.
      */
-    destflags = flags & ~(VIR_MIGRATE_PEER2PEER);
+    destflags = props->virFlags & ~(VIR_MIGRATE_PEER2PEER);
 
     VIR_DEBUG("Prepare3");
     virObjectUnlock(vm);
-    if (flags & VIR_MIGRATE_TUNNELLED) {
+    if (props->virFlags & VIR_MIGRATE_TUNNELLED) {
         if (!(st = virStreamNew(dconn, 0)))
             goto confirm;
         ret = dconn->driver->domainMigratePrepareTunnel3Params
@@ -1059,7 +1080,7 @@ libxlDoMigrateP2P(libxlDriverPrivatePtr
     if (ret == -1)
         goto confirm;
 
-    if (!(flags & VIR_MIGRATE_TUNNELLED)) {
+    if (!(props->virFlags & VIR_MIGRATE_TUNNELLED)) {
         if (uri_out) {
             if (virTypedParamsReplaceString(&params, &nparams,
                                             VIR_MIGRATE_PARAM_URI, uri_out) < 0) {
@@ -1074,11 +1095,11 @@ libxlDoMigrateP2P(libxlDriverPrivatePtr
     }
 
     VIR_DEBUG("Perform3 uri=%s", NULLSTR(uri_out));
-    if (flags & VIR_MIGRATE_TUNNELLED)
-        ret = libxlMigrationStartTunnel(driver, vm, flags, st, &tc);
+    if (props->virFlags & VIR_MIGRATE_TUNNELLED)
+        ret = libxlMigrationStartTunnel(driver, vm, props, st, &tc);
     else
         ret = libxlDomainMigrationPerform(driver, vm, NULL, NULL,
-                                          uri_out, NULL, flags);
+                                          uri_out, NULL, props);
     if (ret < 0) {
         notify_source = false;
         orig_err = virSaveLastError();
@@ -1113,7 +1134,7 @@ libxlDoMigrateP2P(libxlDriverPrivatePtr
  confirm:
     if (notify_source) {
         VIR_DEBUG("Confirm3 cancelled=%d vm=%p", cancelled, vm);
-        ret = libxlDomainMigrationConfirm(driver, vm, flags, cancelled);
+        ret = libxlDomainMigrationConfirm(driver, vm, props->virFlags, cancelled);
 
         if (ret < 0)
             VIR_WARN("Guest %s probably left in 'paused' state on source",
@@ -1121,7 +1142,7 @@ libxlDoMigrateP2P(libxlDriverPrivatePtr
     }
 
  cleanup:
-    if (flags & VIR_MIGRATE_TUNNELLED) {
+    if (props->virFlags & VIR_MIGRATE_TUNNELLED) {
         libxlMigrationStopTunnel(tc);
         virObjectUnref(st);
     }
@@ -1168,7 +1189,7 @@ libxlDomainMigrationPerformP2P(libxlDriv
                                const char *dconnuri,
                                const char *uri_str ATTRIBUTE_UNUSED,
                                const char *dname,
-                               unsigned int flags)
+                               const libxlDomainMigrationProps *props)
 {
     int ret = -1;
     bool useParams;
@@ -1203,7 +1224,7 @@ libxlDomainMigrationPerformP2P(libxlDriv
     }
 
     ret = libxlDoMigrateP2P(driver, vm, sconn, xmlin, dconn, dconnuri,
-                            dname, uri_str, flags);
+                            dname, uri_str, props);
 
     if (ret < 0) {
         /*
@@ -1233,7 +1254,7 @@ libxlDomainMigrationPerform(libxlDriverP
                             const char *dconnuri ATTRIBUTE_UNUSED,
                             const char *uri_str,
                             const char *dname ATTRIBUTE_UNUSED,
-                            unsigned int flags)
+                            const libxlDomainMigrationProps *props)
 {
     libxlDomainObjPrivatePtr priv = vm->privateData;
     char *hostname = NULL;
@@ -1269,7 +1290,7 @@ libxlDomainMigrationPerform(libxlDriverP
 
     /* suspend vm and send saved data to dst through socket fd */
     virObjectUnlock(vm);
-    ret = libxlDoMigrateSend(driver, vm, flags, sockfd);
+    ret = libxlDoMigrateSend(driver, vm, props, sockfd);
     virObjectLock(vm);
 
     if (ret == 0) {
Index: libvirt-4.0.0/src/libxl/libxl_migration.h
===================================================================
--- libvirt-4.0.0.orig/src/libxl/libxl_migration.h
+++ libvirt-4.0.0/src/libxl/libxl_migration.h
@@ -39,6 +39,10 @@
     VIR_MIGRATE_PARAM_URI,              VIR_TYPED_PARAM_STRING, \
     VIR_MIGRATE_PARAM_DEST_NAME,        VIR_TYPED_PARAM_STRING, \
     VIR_MIGRATE_PARAM_DEST_XML,         VIR_TYPED_PARAM_STRING, \
+    VIR_MIGRATE_PARAM_SUSE_MAX_ITERS,   VIR_TYPED_PARAM_UINT, \
+    VIR_MIGRATE_PARAM_SUSE_MAX_FACTOR,  VIR_TYPED_PARAM_UINT, \
+    VIR_MIGRATE_PARAM_SUSE_MIN_REMAINING, VIR_TYPED_PARAM_UINT, \
+    VIR_MIGRATE_PARAM_SUSE_ABORT_IF_BUSY, VIR_TYPED_PARAM_UINT, \
     NULL
 
 char *
@@ -70,6 +74,14 @@ libxlDomainMigrationPrepare(virConnectPt
                             int cookieinlen,
                             unsigned int flags);
 
+typedef struct {
+    unsigned int virFlags;
+    unsigned int max_iters;
+    unsigned int max_factor;
+    unsigned int min_remaining;
+    unsigned int abort_if_busy;
+} libxlDomainMigrationProps;
+
 int
 libxlDomainMigrationPerformP2P(libxlDriverPrivatePtr driver,
                                virDomainObjPtr vm,
@@ -78,7 +90,7 @@ libxlDomainMigrationPerformP2P(libxlDriv
                                const char *dconnuri,
                                const char *uri_str,
                                const char *dname,
-                               unsigned int flags);
+                               const libxlDomainMigrationProps *props);
 
 int
 libxlDomainMigrationPerform(libxlDriverPrivatePtr driver,
@@ -87,7 +99,7 @@ libxlDomainMigrationPerform(libxlDriverP
                             const char *dconnuri,
                             const char *uri_str,
                             const char *dname,
-                            unsigned int flags);
+                            const libxlDomainMigrationProps *props);
 
 virDomainPtr
 libxlDomainMigrationFinish(virConnectPtr dconn,
Index: libvirt-4.0.0/tools/virsh-domain.c
===================================================================
--- libvirt-4.0.0.orig/tools/virsh-domain.c
+++ libvirt-4.0.0/tools/virsh-domain.c
@@ -10544,6 +10544,22 @@ static const vshCmdOptDef opts_migrate[]
      .type = VSH_OT_INT,
      .help = N_("migration bandwidth limit in MiB/s")
     },
+    {.name = "max_iters",
+     .type = VSH_OT_INT,
+     .help = N_("SUSE libxl: Number of iterations before final suspend (default: 30).")
+    },
+    {.name = "max_factor",
+     .type = VSH_OT_INT,
+     .help = N_("SUSE libxl: Max amount of memory to transfer before final suspend (default: 3*RAM).")
+    },
+    {.name = "min_remaining",
+     .type = VSH_OT_INT,
+     .help = N_("SUSE libxl: Number of dirty pages before final suspend (default: 50).")
+    },
+    {.name = "abort_if_busy",
+     .type = VSH_OT_BOOL,
+     .help = N_("SUSE libxl: Abort migration instead of doing final suspend.")
+    },
     {.name = NULL}
 };
 
@@ -10567,6 +10583,7 @@ doMigrate(void *opaque)
     unsigned long long ullOpt = 0;
     int rv;
     virConnectPtr dconn = data->dconn;
+    unsigned int uint_opt = 0;
 
     sigemptyset(&sigmask);
     sigaddset(&sigmask, SIGINT);
@@ -10686,6 +10703,27 @@ doMigrate(void *opaque)
             goto save_error;
     }
 
+    if (vshCommandOptUInt(ctl, cmd, "max_iters", &uint_opt) > 0 && uint_opt) {
+        if (virTypedParamsAddUInt(&params, &nparams, &maxparams,
+                                VIR_MIGRATE_PARAM_SUSE_MAX_ITERS, uint_opt) < 0)
+            goto save_error;
+    }
+    if (vshCommandOptUInt(ctl, cmd, "max_factor", &uint_opt) > 0 && uint_opt) {
+        if (virTypedParamsAddUInt(&params, &nparams, &maxparams,
+                                VIR_MIGRATE_PARAM_SUSE_MAX_FACTOR, uint_opt) < 0)
+            goto save_error;
+    }
+    if (vshCommandOptUInt(ctl, cmd, "min_remaining", &uint_opt) > 0 && uint_opt) {
+        if (virTypedParamsAddUInt(&params, &nparams, &maxparams,
+                                VIR_MIGRATE_PARAM_SUSE_MIN_REMAINING, uint_opt) < 0)
+            goto save_error;
+    }
+    if (vshCommandOptBool(cmd, "abort_if_busy")) {
+        if (virTypedParamsAddUInt(&params, &nparams, &maxparams,
+                                VIR_MIGRATE_PARAM_SUSE_ABORT_IF_BUSY, 1) < 0)
+            goto save_error;
+    }
+
     if (vshCommandOptStringReq(ctl, cmd, "xml", &opt) < 0)
         goto out;
     if (opt) {
Index: libvirt-4.0.0/tools/virsh.pod
===================================================================
--- libvirt-4.0.0.orig/tools/virsh.pod
+++ libvirt-4.0.0/tools/virsh.pod
@@ -1852,6 +1852,14 @@ Providing I<--tls> causes the migration
 the migration of the domain. Usage requires proper TLS setup for both source
 and target.
 
+SUSE-specific options for Xen: I<--max_iters> B<num> allows specifying the maximum
+number of iterations before final suspend. Default is 30. I<--max_factor> B<num>
+allows specifying the maximum amount of memory to transfer before final suspend.
+Default is (3*VM memory size). I<--min_remaining> B<num> allows specifying the
+number of dirty pages before final suspend.  Default is 50. I<--abort_if_busy>
+can be used to abort the migration instead of doing the final suspend for VMs with
+busy workloads.
+
 Running migration can be canceled by interrupting virsh (usually using
 C<Ctrl-C>) or by B<domjobabort> command sent from another virsh instance.
 